---
- name: Get service facts on running machine
  service_facts:

- name: Check if update needed
  set_fact:
    mirror_registry_install_command: "{% if ansible_facts.services['quay-app.service'].state == 'running' %}upgrade{% else %}install{% endif %}"

- name: Ensure directories exists
  file:
    path: "{{ item.path }}"
    state: directory
  when: item.cond | default(True)
  loop:
    - path: "{{ mirror_registry_download_dir }}"
    - path: "{{ mirror_registry.directory }}"
    - path: "{{ mirror_registry.pgstorage | default('') }}"
      cond: "{{ mirror_registry.pgstorage is defined }}"
    - path: "{{ mirror_registry.quaystorage | default('') }}"
      cond: "{{ mirror_registry.quaystorage is defined }}"

- name: Download and extract mirror-registry tool
  unarchive:
    dest: "{{ mirror_registry_download_dir }}"
    src: "{{ mirror_registry_download_url }}"
    remote_src: true
  tags:
  - download

- name: Slurp certs and setup for mirror-registry
  include_tasks: mirror_registry_slurp_and_create.yml
  when:
  - mirror_registry_cert.certfile is defined or mirror_registry_cert.cert_content is defined
  - mirror_registry_cert.keyfile is defined or mirror_registry_cert.key_content is defined

- name: Run installer
  command:
    cmd: "{{ lookup('template', 'mirror-registry-command.j2') | replace('\n', ' ') }}"
    chdir: "{{ mirror_registry_download_dir }}"
  register: mirror_registry_install_output
#  failed_when:
#  - mirror_registry_install_output.stderr != ''
  tags:
  - mirror_registry_run_installer

- name: debug
  debug:
    var: mirror_registry_install_output
